import pygame
from pygame import Vector2
from math import sin, radians, cos, tan
from random import randint
# 896 728

pygame.init()
wn = pygame.display.set_mode((896, 728), pygame.RESIZABLE)

pygame.display.set_caption("Run!")
clock=pygame.time.Clock()

nrouh=pygame.mixer.Sound("./sound/nrooooUH.wav")
bg_music=pygame.mixer.Sound("./sound/fast1.wav")
player_hit=pygame.mixer.Sound("./sound/PlayerHit.wav")
bullet_fire=pygame.mixer.Sound("./sound/fire.wav")
boss_fire=pygame.mixer.Sound("./sound/bossfire.wav")
global floor_img
global boss
hpup_img=pygame.image.load("./img/HpUp.png").convert_alpha()
bulletsup_img=pygame.image.load("./img/SplitShot.png").convert_alpha()
attackup_img=pygame.image.load("./img/DmgUp.png").convert_alpha()
floor_img_close = pygame.image.load("./img/Floor-Close.png").convert_alpha()
floor_img_open = pygame.image.load("./img/Floor-Open.png").convert_alpha()
floor_img=floor_img_close
floor_rect=floor_img.get_rect()
player_img = pygame.image.load("./img/Player.png").convert_alpha()
EvilTwin_img = pygame.image.load("./img/EvilTwin.png").convert_alpha()
Pbullet_img = pygame.image.load("./img/PlayerBullet.png").convert_alpha()
heartE_img = pygame.image.load("./img/HeartEmpty.png").convert_alpha()
heartF_img = pygame.image.load("./img/HeartFull.png").convert_alpha()
muncherI=pygame.image.load("./img/muncher/muncherIdle.png").convert_alpha()
muncherI = pygame.transform.scale(muncherI, (42, 60))
muncherJump=pygame.image.load("./img/muncher/MuncherJumping.png").convert_alpha()
muncherJump = pygame.transform.scale(muncherJump, (42, 60))
muncherSq=pygame.image.load("./img/muncher/MuncherSquash.png").convert_alpha()
muncherSq = pygame.transform.scale(muncherSq, (42, 60))
wl_img=pygame.image.load("./img/CollisionWallLeft.png").convert_alpha()
swanfont48 = pygame.font.Font("./img/Swansea.ttf", 48)
buttons=[]

def RGB_to_HEX(x):
    x1=hex(x[0])[2:]
    x2=hex(x[1])[2:]
    x3=hex(x[2])[2:]
    return f"#{x1}{x2}{x3}"

class Button():
    def __init__(self, action, width, height, x, y, color, text, textcolor):
        self.action=action
        self.rect = pygame.Rect(x-(width/2), y-(height/2), width, height)
        self.rect.center = (x, y)
        buttons.append(self)
        self.color = pygame.Color(color[0], color[1], color[2], 255)
        self.renderedtext=swanfont48.render(text, True, textcolor, RGB_to_HEX(color))
        self.Textrect=self.renderedtext.get_rect()
        self.Textrect.center=(x, y)
        self.rect.width+=20

    def isclicked(self, mx, my):
        if self.rect.collidepoint(mx, my):
            if self in buttons:
                buttons.pop(buttons.index(self))
            self.action()
            return True

        else:
            return False


    def draw(self):
        pygame.draw.rect(wn, self.color, self.rect)
        wn.blit(self.renderedtext, self.Textrect)

def game_over():
    bg_music.stop()
    restart=Button(main, 200, 100, 896/2-25, 728/2-50, (100, 100, 100), "Restart", (200, 10, 10))
    while True:
        wn.fill((0, 0, 0))
        for event in pygame.event.get():
            if event.type == pygame.MOUSEBUTTONDOWN:
                mx, my = event.pos
                for button in buttons:
                    button.isclicked(mx, my)
            if event.type == pygame.QUIT:
                pygame.quit()
                exit()
        for i in buttons:
            i.draw()
        pygame.display.update()



def win():
    bg_music.stop()
    restart=Button(main, 200, 100, 896/2-25, 728/2-50, (200, 200, 200), "Restart", (230, 40, 40))
    r=40
    g=200
    b=120
    while True:
        r+=randint(-1, 2)
        g+=randint(-3, 2)
        b+=randint(-2, 3)
        try:
            wn.fill((r, g, b))
        except:
            r-=1
            g-=1
            b-=1
        for event in pygame.event.get():
            if event.type == pygame.MOUSEBUTTONDOWN:
                mx, my = event.pos
                for button in buttons:
                    button.isclicked(mx, my)
            if event.type == pygame.QUIT:
                pygame.quit()
                exit()
        for i in buttons:
            i.draw()
        pygame.display.update()




def main():
    wlr=wl_img.get_rect()
    wlr.center=(53, 350)
    wlt=pygame.Rect((0, 53), (896, 1))

    bg_music.play(1000)
    wlb=pygame.Rect((0, 728-53), (896, 1))
    wlr1=pygame.Rect((896-53, 0), (1, 728/3-50))
    wlr2=pygame.Rect((896-53, 728/3*2+40), (1, 728/3-50))
    wlr3=pygame.Rect((896-53, 0), (1, 728))

    muncher_intro = [pygame.transform.scale(pygame.image.load(f"./img/muncher/MuncherIntro{i+1}.png").convert_alpha(), (42, 60)) for i in range(7)]
    all=[]
    buttons=[]
    Pbullets=[]
    hearts=[]
    enemys=[]
    powerups=[]
    #player_img = pygame.image.load("./img/EvilTwin.png").convert_alpha()]

    class Manager():
        def __init__(self):
            self.Cleared=False
            self.level=0
            self.bosscleared=False
            self.powerupschosen=False
            self.bulletdamage=1
            self.rect=pygame.Rect((896-20, 728/3), (2, 728/3))

        def new(self):
            player.speed+=0.2
            self.level+=1
            self.Cleared=False
            global boss
            try:
                del boss
            except:
                pass
            while len(Pbullets) > 0:
                try:
                    Pbullets.pop(0)
                except: pass
            while len(powerups) > 0:
                powerups.pop(0)
            while len(buttons) > 0:
                buttons.pop(0)
            self.powerupschosen=False
            print(self.level)
            if self.level == 11:
                boss=Boss(1000, True)
                return
            for i in range(int(self.level * 2.5+0.5)):
                enemys.append(Muncher(randint(60, 800), randint(20, 60), 1))

        def update(self):
            global floor_img
            if len(enemys) == 0:
                self.Cleared=True
                enemys.append(placeholder())
                floor_img=floor_img_open

            if self.rect.colliderect(player.rect):
                floor_img=floor_img_close
                hpup=Button(200, 300, hpup_img, addhp)
                bulletup=Button(450, 300, bulletsup_img, addbullet)
                dmgup=Button(700, 300, attackup_img, addamage)
                self.Cleared=False
                player.rect.x=100

    class base (pygame.sprite.Sprite):
        def __init__(self, x, y, img, tag):
            pygame.sprite.Sprite.__init__(self)
            self.x=x
            self.y=y
            self.tag=tag
            self.img=img
            all.append(self)




    class Boss(base):
        def __init__(self, timelimit, final):
            super().__init__(100, 100, EvilTwin_img, "Boss")
            self.bullets=11
            self.final=final
            self.damage=2
            self.hp=50
            if final:
                self.hp=75
            self.rect=self.img.get_rect()
            self.bulletspread=165
            self.flip=False
            self.timelimit=timelimit * 1000
            self.starttime=pygame.time.get_ticks() + timelimit * 1000
            self.rect.center=(600, 90)
            self.x=self.rect.x
            self.y=self.rect.y

        def fight(self, shoot, repeat):
            t=pygame.time.get_ticks()
            for i in Pbullets:
                if self.rect.colliderect(i.rect):
                    if i.from_player == True:
                        self.hp-=1
                        i.rect.center=(1000, 1000)
                        Pbullets.pop(Pbullets.index(i))
            if t > self.starttime or self.hp <= 0:
                if self.final:
                    win()
                enemys.pop(0)
                manager.bosscleared=True
                manager.new()
                return
            if player.rect.x > self.rect.x: 
                self.flip=False
                self.x+=0.5

            else: 
                self.x-=0.5
                self.flip=True
            if player.rect.y > self.rect.y:
                self.y+=0.5
            else:
                self.y-=0.5

            self.rect.x = self.x-30
            self.rect.y=self.y-80
            self.flip= not self.flip
            self.bulletspread+=2
            


            if shoot % 130 == 0 or (shoot % 90 == 0 and self.final):
                x=player.rect.x + (player.rect.width /2 + 10)
                y=player.rect.y + 30
                speed = 7
                current = Vector2(self.rect.x,self.rect.y)
                target = Vector2(x, y)

                move_vector = (target - current)

                movex, movey = move_vector.normalize() * speed
                p=bullet(self.rect.x+30, self.rect.y+80, False, movex, movey, tan((player.rect.y - self.rect.y) / (player.rect.x-self.rect.x)))
                boss_fire.play(0)
                deg=self.bulletspread*3
                x= int((cos(radians(deg)) * 7)+0.5)
                y= -int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, False, x, y, deg)
                deg=self.bulletspread*4
                x= int((cos(radians(deg)) * 7)+0.5)
                y= int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, False, x, y, -deg)
                deg=self.bulletspread*4
                x= int((cos(radians(deg)) * 7)+0.5)
                y= -int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, False, x, y, deg)
                deg=self.bulletspread*5
                x= int((cos(radians(deg)) * 7)+0.5)
                y= int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, False, x, y, -deg)
                deg=self.bulletspread*5
                x= int((cos(radians(deg)) * 7)+0.5)
                y= -int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, False, x, y, deg)

            self.flip=not self.flip
            if repeat:
                return
            wn.blit(pygame.transform.flip(self.img, self.flip, False), self.rect)
            self.fight(shoot, True)






    class bullet(base):
        def __init__(self, x, y, player, xvel, yvel, direction):
            super().__init__(x, y, pygame.transform.rotate(Pbullet_img, direction), "Pbullet")
            self.from_player=player
            self.xvel=xvel
            self.yvel=yvel
            self.rect=pygame.transform.rotate(Pbullet_img, direction).get_rect()
            self.rect.center=(x, y)
            Pbullets.append(self)

        def update(self):
            self.rect.x+=self.xvel
            self.rect.y+=self.yvel
            self.draw()

        def draw(self):
            wn.blit(self.img, self.rect)



    class Muncher(base):
        def __init__(self, x, y, inctime):
            super().__init__(x, y, muncherI, "muncher")
            self.starttime=pygame.time.get_ticks()
            self.falling=True
            self.jumping=False
            self.jumptimer=self.starttime+1500
            self.hp=3
            self.target=(0, 0)
            self.rect=self.img.get_rect()
            self.rect.center=(x, y)
            self.velx=0
            self.vely=0
            self.stop=0
            enemys.append(self)

        
        def enemy(self):
            t=pygame.time.get_ticks()
            if t - self.starttime > 15000:
                p=Muncher(self.x+40, self.y+40, 15)
                enemys.append(p)
                self.starttime=t
            if t-self.starttime > 525:
                self.falling=False

            if self.falling:
                try:
                    self.img = muncher_intro[int((t-self.starttime)/75)]
                except:
                    self.falling=False
            elif not self.jumping:
                self.img=muncherI
            else:
                self.img=muncherJump



            if self.jumptimer < t and not self.falling:
                nrouh.play(0)
                self.jumptimer = t + 3200 + randint(-500, 500)
                self.stop=t+2400
                self.velx = (player.x-self.rect.x+55) /150
                self.vely = (player.y -self.rect.y+35)/ 150
                self.jumping=True
                self.target = (player.x, player.y)
                self.img=muncherSq
            
            if self.vely > 7:
                self.vely = 7
            if self.vely < -7:
                self.vely = -7

            if self.velx > 7:
                self.velx = 7
            if self.velx < -7:
                self.velx = -7


            if self.y < 0:
                self.rect.y+=self.vely+5
                self.vely=0
                self.velx=0
            if self.y +40> 728:
                self.rect.y-=self.vely + 5
                self.vely=0
                self.velx=0

            if self.x < 0:
                self.rect.x+=self.velx+5
                self.velx=0
                self.vely=0
            if self.x +60> 896:
                self.rect.x-=self.velx + 5
                self.velx=0
                self.vely=0

            if self.stop < t:
                self.jumping=False
                self.velx=0
                self.vely=0
            bulletkill=[]
            for i in Pbullets:
                if self.rect.colliderect(i.rect):
                    if self.hp - manager.bulletdamage <= 0:
                        if self.hp == 0.1:
                            
                            self.hp-=manager.bulletdamage
                        else:

                            self.hp = 0.1
                    else: self.hp -= manager.bulletdamage
                    bulletkill.append(Pbullets.index(i))
            if len(bulletkill) > 0:
                bulletkill[0]+=1
                for i in bulletkill:
                    i-=1
                    try:
                        
                        Pbullets.pop(i)
                    except: pass
            
            if self.hp < 0:
                enemys.pop(enemys.index(self))

            if self.rect.colliderect(player.rect):
                if player.iframes < t:
                    player.hp-=1
                    player_hit.play(0)
                    player.iframes=t+300
                else:
                    pass
                if player.rect.x > self.rect.x:
                    self.rect.x -= 8
                else:
                    self.rect.x += 8
                self.velx*=-1
                self.vely*=-1
            self.rect.x+=self.velx
            self.rect.y+=self.vely
            self.x = self.rect.x
            self.y = self.rect.y

        def draw(self):
            wn.blit(self.img, self.rect)


    class Player(base):
        def __init__(self):
            super().__init__(400, 400, player_img, "player")
            self.rect=player_img.get_rect()
            self.rect.center = (self.x, self.y)
            self.ml=False
            self.mr=False
            self.md=False
            self.mu=False
            self.velx=0
            self.vely=0
            self.flip=False
            self.hp=2
            self.speed=1.6
            self.bulletspread=15
            self.iframes=pygame.time.get_ticks()

            #powerups
            self.attack=1
            self.bullets=1
            self.maxhp=2



        def control(self):
            if self.hp <= 0:
                game_over()
            
            if self.ml and not self.mr:
                self.velx=-2
                self.flip=True
            elif self.mr and not self.ml:
                self.velx=2
                self.flip=False
            if self.mu and not self.md:
                self.vely=-2
            elif self.md and not self.mu:
                self.vely=2

            self.rect.x+=self.velx*self.speed
            self.rect.y+=self.vely*self.speed

            self.x=self.rect.x + 20
            self.y=self.rect.y+40

            t=pygame.time.get_ticks()
            for i in Pbullets:
                if self.rect.colliderect(i.rect):
                    if i.from_player == False:
                        if self.iframes <t:
                            self.hp-=1
                            player_hit.play(0)
                            self.iframes=t+300
                        else: pass
                        i.rect.center=(1000, 1000)
                        Pbullets.pop(Pbullets.index(i))
            if self.rect.colliderect(wlr):
                self.rect.x= 0+52
            if self.rect.colliderect(wlt):
                self.rect.y= 0+ 53
            if self.rect.colliderect(wlb):
                self.rect.y = 728 - 26 - 112
            if self.rect.colliderect(wlr1):
                self.rect.x = wlr1.x -1 - 55
            if self.rect.colliderect(wlr2):
                self.rect.x = wlr1.x -1 - 55
            if self.rect.colliderect(wlr3) and manager.Cleared == False and manager.level != 11:
                self.rect.x = wlr3.x -1 - 55
            self.velx/=1.1
            self.vely/=1.1
            if self.velx < 1 and self.velx > -1:
                self.velx=0
            if self.vely < 1 and self.vely > -1:
                self.vely=0

        def shoot(self):
            
            
            bullets=self.bullets
            if bullets >0:
                #x= int((cos(radians(deg)) * 5)+0.5)
                #y= int((sin(radians(deg)) * 5)+0.5)
                if self.flip:
                    x=-7
                else:
                    x=7
                y=0
                s=bullet(self.x, self.y, True, x, y, 0)
                bullet_fire.play(0)
            if bullets > 1:
                deg=self.bulletspread
                x= int((cos(radians(deg)) * 7)+0.5)
                y= int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, True, x, y, -deg)

            if bullets > 2:
                deg=self.bulletspread
                x= int((cos(radians(deg)) * 7)+0.5)
                y= -int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, True, x, y, deg)
            if bullets > 3:
                deg=self.bulletspread*2
                x= int((cos(radians(deg)) * 7)+0.5)
                y= int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, True, x, y, -deg)
            if bullets > 4:
                deg=self.bulletspread*2
                x= int((cos(radians(deg)) * 7)+0.5)
                y= -int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, True, x, y, deg)
            if bullets > 5:
                deg=self.bulletspread*3
                x= int((cos(radians(deg)) * 7)+0.5)
                y= int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, True, x, y, -deg)
            if bullets > 6:
                deg=self.bulletspread*3
                x= int((cos(radians(deg)) * 7)+0.5)
                y= -int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, True, x, y, deg)
            if bullets > 7:
                deg=self.bulletspread*4
                x= int((cos(radians(deg)) * 7)+0.5)
                y= int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, True, x, y, -deg)
            if bullets > 8:
                deg=self.bulletspread*4
                x= int((cos(radians(deg)) * 7)+0.5)
                y= -int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, True, x, y, deg)
            if bullets > 9:
                deg=self.bulletspread*5
                x= int((cos(radians(deg)) * 7)+0.5)
                y= int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, True, x, y, -deg)
            if bullets > 10:
                deg=self.bulletspread*5
                x= int((cos(radians(deg)) * 7)+0.5)
                y= -int((sin(radians(deg)) * 7)+0.5)
                if self.flip:
                    x*=-1
                s=bullet(self.x, self.y, True, x, y, deg)


        def draw(self):
            wn.blit(pygame.transform.flip(self.img, self.flip, False), self.rect)

    def addamage():
        manager.bulletdamage+=1
        manager.powerupschosen=True
        global boss
        while len(buttons) > 0:
            buttons.pop(0)
        boss=Boss(manager.level * 3, False)
        boss.fight(50, False)

    def addbullet():
        if manager.bulletdamage > 0.5:
            manager.bulletdamage-=0.5
        player.bullets+=1
        manager.powerupschosen=True
        global boss
        while len(buttons) > 0:
            buttons.pop(0)
        boss=Boss(manager.level * 3, False)
        boss.fight(50, False)

    def addhp():
        player.maxhp+=1
        player.hp=player.maxhp
        s=heart(player.maxhp, 35+(70*len(hearts)), 30)
        manager.powerupschosen=True
        global boss
        while len(buttons) > 0:
            buttons.pop(0)
        boss=Boss(manager.level * 3, False)
        boss.fight(50, False)


    class Button():
        def __init__(self, x, y, img, action):
            self.x=x
            self.y=y
            self.img=img
            self.rect=self.img.get_rect()
            self.rect.center=(x, y)
            self.action=action
            buttons.append(self)
        
        def draw(self):
            wn.blit(self.img, self.rect)

        def isclicked(self, mx, my):

            if manager.powerupschosen:
                buttons.pop(buttons.index(self))
            if self.rect.collidepoint(mx, my):
                if self in buttons:
                    buttons.pop(buttons.index(self))
                    self.action()
                return True

            else:
                return False



    class heart(base):
        def __init__(self, hp, x, y):
            super().__init__(x, y, heartF_img, "heart")
            self.open=heartF_img
            self.close=heartE_img
            self.hp2close=hp
            self.rect=self.img.get_rect()
            self.rect.center=(x, y)
            hearts.append(self)

        def update(self):
            if player.hp < self.hp2close:
                self.img=self.close
            else:
                self.img=self.open
            wn.blit(self.img, self.rect)

    class placeholder():
        def __init__(self):
            pass
        def update(self):
            pass
        def draw(self):
            pass
        def enemy(self):
            pass

    player=Player()
    manager=Manager()
    manager.new()
    h1=heart(1, 35, 30)
    h2=heart(2, 105, 30)
    p=0
    timesinceshoot=pygame.time.get_ticks()
    while True:
        t=pygame.time.get_ticks()
        p+=1
        wn.fill((155, 55, 200))
        wn.blit(floor_img, floor_rect)
        pressl=False
        pressr=False
        for i in Pbullets:
            i.update()
        for i in hearts:
            i.update()
        for i in enemys:
            i.draw()
            i.enemy()
        player.draw()
        try:
            boss.fight(p, False)
        except: pass
        manager.update()
        for i in buttons:
            i.draw()
        for event in pygame.event.get():
            
            if event.type == pygame.QUIT:
                pygame.quit()
                exit()
            if event.type == pygame.MOUSEBUTTONDOWN:
                mx, my = event.pos
                for button in buttons:
                    button.isclicked(mx, my)


            if event.type == pygame.KEYDOWN:
                key=event.key
                if key == pygame.K_a or key == pygame.K_LEFT:
                    player.ml=True
                if key == pygame.K_d or key == pygame.K_RIGHT:
                    player.mr=True 
                if key == pygame.K_w or key == pygame.K_UP:
                    player.mu=True
                if key == pygame.K_s or key == pygame.K_DOWN:
                    player.md=True 
                if key == pygame.K_SPACE and t > timesinceshoot:
                    player.shoot()
                    timesinceshoot=t+300


            if event.type == pygame.KEYUP:
                key=event.key
                if key == pygame.K_a or key == pygame.K_LEFT:
                    player.ml=False
                if key == pygame.K_d or key == pygame.K_RIGHT:
                    player.mr=False 
                if key == pygame.K_w or key == pygame.K_UP:
                    player.mu=False
                if key == pygame.K_s or key == pygame.K_DOWN:
                    player.md=False 
        player.control()
        pygame.display.update()
        clock.tick(60)


main()